/*************************************************  Product Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2014, Red Rapids, Inc.

*************************************************  Product Functions Header  **************************************************/

#ifndef _PRODUCT_FUNCTIONS_H_
#define _PRODUCT_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to reference all of the device configuration settings for a Model 371.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M371Devices;

// Structure to reference all of the device configuration settings for a Model 376.
typedef struct
{
	s_ADC12D1600 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
} s_M376Devices;

// Structure to reference all of the device configuration settings for a Model 377.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_ADS42LB69 RX3TO4_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_LTC1661 RX3_TRIM_DAC;
	s_LTC1661 RX4_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADL5566 RX3TO4_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M377Devices;

// Prototypes for each of the device functions.
unsigned long M371Initialize(s_Adapter *p_HW, s_M371Devices M371Devices, s_Channel *p_RXChannel);
unsigned long M376Initialize(s_Adapter *p_HW, s_M376Devices M376Devices, s_Channel *p_RXChannel);
unsigned long M377Initialize(s_Adapter *p_HW, s_M377Devices M377Devices, s_Channel *p_RXChannel);

#ifdef __cplusplus
}
#endif

#endif
